GNU bug report logs - #46256
[feature/native-comp] AOT eln files ignored if run from build tree

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Andy Moreton <andrewjmoreton@HIDDEN>; Done: Andrea Corallo <akrl@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 1 Mar 2021 09:49:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 01 04:49:10 2021
Received: from localhost ([127.0.0.1]:48134 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lGfAs-0004J5-Ej
	for submit <at> debbugs.gnu.org; Mon, 01 Mar 2021 04:49:10 -0500
Received: from lists.gnu.org ([209.51.188.17]:59340)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lGfAr-0004Iy-6Q
 for submit <at> debbugs.gnu.org; Mon, 01 Mar 2021 04:49:09 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:34070)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lGfAq-0001U0-T7
 for bug-gnu-emacs@HIDDEN; Mon, 01 Mar 2021 04:49:08 -0500
Received: from ciao.gmane.io ([116.202.254.214]:51572)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lGfAp-0007G1-JF
 for bug-gnu-emacs@HIDDEN; Mon, 01 Mar 2021 04:49:08 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lGfAl-0002zI-Gi
 for bug-gnu-emacs@HIDDEN; Mon, 01 Mar 2021 10:49:03 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
Date: Mon, 01 Mar 2021 09:48:57 +0000
Message-ID: <86ft1f8ara.fsf@HIDDEN>
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN> <xjfft1he31v.fsf@HIDDEN>
 <86wnut8fb9.fsf@HIDDEN> <861rd1tbpa.fsf@HIDDEN>
 <83pn0km6y3.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:ZLd6eF7cBxaNiXUCY95dVEHI4po=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.25, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Sun 28 Feb 2021, Eli Zaretskii wrote:

>> From: Andy Moreton <andrewjmoreton@HIDDEN>
>> Date: Sat, 27 Feb 2021 21:58:25 +0000
>> 
>> > I suspect that the issue may be with parallel builds (note the "-j8"
>> > above). Repeating the build with "-j1" appears to be building the
>> > missing .eln files as expected.
>> 
>> Now that the -j1 build has completed (without error), all of the lisp
>> files have been compiled AOT as expected, and running the resulting
>> emacs does not rebuild any of those .eln files.
>> 
>> So I think there are still some other issues with dependencies and
>> handling parallel builds, but this bug has been fixed.
>
> Hmm... what would be the reason for parallel builds not work well on
> MS-Windows? file sharing issues?
>
> Does the async native compilation use temporary files, and if so, do
> they reside in the same directory when multiple compilations are
> running?

I've tried a few builds from a clean tree (after "git clean -xdf") and
have note  been able to reproduce this parallel build problem again.

Do let me know if there are any steps I should take to help diagnose it
if it does reproduce again.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 1 Mar 2021 06:34:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 01 01:34:36 2021
Received: from localhost ([127.0.0.1]:47867 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lGc8a-0007qi-CS
	for submit <at> debbugs.gnu.org; Mon, 01 Mar 2021 01:34:36 -0500
Received: from mx.sdf.org ([205.166.94.24]:55920)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lGc8Y-0007qa-Jw
 for 46256 <at> debbugs.gnu.org; Mon, 01 Mar 2021 01:34:35 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 1216YWEQ001296
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Mon, 1 Mar 2021 06:34:33 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN> <xjfft1he31v.fsf@HIDDEN>
 <86wnut8fb9.fsf@HIDDEN> <861rd1tbpa.fsf@HIDDEN>
 <83pn0km6y3.fsf@HIDDEN> <xjfr1kzdhd4.fsf@HIDDEN>
 <83lfb78mg8.fsf@HIDDEN>
Date: Mon, 01 Mar 2021 06:34:32 +0000
In-Reply-To: <83lfb78mg8.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 01 Mar
 2021 07:36:23 +0200")
Message-ID: <xjfczwjcrgn.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, andrewjmoreton@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: Andy Moreton <andrewjmoreton@HIDDEN>, 46256 <at> debbugs.gnu.org
>> Date: Sun, 28 Feb 2021 21:15:03 +0000
>> 
>> > Does the async native compilation use temporary files, and if so, do
>> > they reside in the same directory when multiple compilations are
>> > running?
>> 
>> Yes, we rely on Fmake_temp_file_internal in Fcomp__compile_ctxt_to_file
>> to decide the output filename to be passed to libgccjit when asking for
>> compilation.
>
> That shouldn't cause a problem, I think.
>
>> There should be no conflict unless more then one process is trying to
>> compile the same file
>
> Is there a way to print to some log file the names of the files being
> compiled?  Then perhaps we could catch such multiple compilations.

We don't have any log facility ATM for that.

Yesterday evening testing a patch I had the same issue, it should be
sufficient to add some print.  I'll try to look into.

> AFAIR, the Emacs build process divides files into several groups, and
> no 2 groups include the same file.  So the top-level compilation
> process cannot cause multiple compilations of the same file.  But
> could it happen that compiling file A indirectly causes file B to be
> compiled, because file A requires B or loads B or calls functions
> declared to be in B, and there's not yet a .eln file for file B?

It should not happen.

When 'noninteractive' is true we disable deferred compilation in
'maybe_defer_native_compilation'.  Reason for this being that we want to
trigger automatic compilations only for reasonably long standing
sessions and very often non interactive ones aren't.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 1 Mar 2021 05:36:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 01 00:36:35 2021
Received: from localhost ([127.0.0.1]:47811 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lGbEQ-0006JG-QI
	for submit <at> debbugs.gnu.org; Mon, 01 Mar 2021 00:36:35 -0500
Received: from eggs.gnu.org ([209.51.188.92]:51524)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lGbEP-0006J3-Es
 for 46256 <at> debbugs.gnu.org; Mon, 01 Mar 2021 00:36:33 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38896)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lGbEK-0006ak-7D; Mon, 01 Mar 2021 00:36:28 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4175
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lGbEI-0002yo-Vu; Mon, 01 Mar 2021 00:36:27 -0500
Date: Mon, 01 Mar 2021 07:36:23 +0200
Message-Id: <83lfb78mg8.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfr1kzdhd4.fsf@HIDDEN> (message from Andrea Corallo on Sun, 28
 Feb 2021 21:15:03 +0000)
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN> <xjfft1he31v.fsf@HIDDEN>
 <86wnut8fb9.fsf@HIDDEN> <861rd1tbpa.fsf@HIDDEN>
 <83pn0km6y3.fsf@HIDDEN> <xjfr1kzdhd4.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, andrewjmoreton@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: Andy Moreton <andrewjmoreton@HIDDEN>, 46256 <at> debbugs.gnu.org
> Date: Sun, 28 Feb 2021 21:15:03 +0000
> 
> > Does the async native compilation use temporary files, and if so, do
> > they reside in the same directory when multiple compilations are
> > running?
> 
> Yes, we rely on Fmake_temp_file_internal in Fcomp__compile_ctxt_to_file
> to decide the output filename to be passed to libgccjit when asking for
> compilation.

That shouldn't cause a problem, I think.

> There should be no conflict unless more then one process is trying to
> compile the same file

Is there a way to print to some log file the names of the files being
compiled?  Then perhaps we could catch such multiple compilations.

AFAIR, the Emacs build process divides files into several groups, and
no 2 groups include the same file.  So the top-level compilation
process cannot cause multiple compilations of the same file.  But
could it happen that compiling file A indirectly causes file B to be
compiled, because file A requires B or loads B or calls functions
declared to be in B, and there's not yet a .eln file for file B?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 28 Feb 2021 21:15:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 28 16:15:07 2021
Received: from localhost ([127.0.0.1]:47348 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lGTP9-0000Ky-5Y
	for submit <at> debbugs.gnu.org; Sun, 28 Feb 2021 16:15:07 -0500
Received: from mx.sdf.org ([205.166.94.24]:63026)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lGTP6-0000Ko-Aj
 for 46256 <at> debbugs.gnu.org; Sun, 28 Feb 2021 16:15:05 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11SLF3Ou026373
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sun, 28 Feb 2021 21:15:03 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN> <xjfft1he31v.fsf@HIDDEN>
 <86wnut8fb9.fsf@HIDDEN> <861rd1tbpa.fsf@HIDDEN>
 <83pn0km6y3.fsf@HIDDEN>
Date: Sun, 28 Feb 2021 21:15:03 +0000
In-Reply-To: <83pn0km6y3.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 28 Feb
 2021 19:35:16 +0200")
Message-ID: <xjfr1kzdhd4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, Andy Moreton <andrewjmoreton@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andy Moreton <andrewjmoreton@HIDDEN>
>> Date: Sat, 27 Feb 2021 21:58:25 +0000
>> 
>> > I suspect that the issue may be with parallel builds (note the "-j8"
>> > above). Repeating the build with "-j1" appears to be building the
>> > missing .eln files as expected.
>> 
>> Now that the -j1 build has completed (without error), all of the lisp
>> files have been compiled AOT as expected, and running the resulting
>> emacs does not rebuild any of those .eln files.
>> 
>> So I think there are still some other issues with dependencies and
>> handling parallel builds, but this bug has been fixed.
>
> Hmm... what would be the reason for parallel builds not work well on
> MS-Windows? file sharing issues?

I suspect this is not Windows related.

> Does the async native compilation use temporary files, and if so, do
> they reside in the same directory when multiple compilations are
> running?

Yes, we rely on Fmake_temp_file_internal in Fcomp__compile_ctxt_to_file
to decide the output filename to be passed to libgccjit when asking for
compilation.

There should be no conflict unless more then one process is trying to
compile the same file (not sure ATM if this is what we are seeing here
and why this should be happening).

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256-done <at> debbugs.gnu.org:


Received: (at 46256-done) by debbugs.gnu.org; 28 Feb 2021 21:04:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 28 16:04:46 2021
Received: from localhost ([127.0.0.1]:47341 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lGTF8-00005l-4e
	for submit <at> debbugs.gnu.org; Sun, 28 Feb 2021 16:04:46 -0500
Received: from mx.sdf.org ([205.166.94.24]:63787)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lGTF6-00005e-Qn
 for 46256-done <at> debbugs.gnu.org; Sun, 28 Feb 2021 16:04:45 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11SL4h07024772
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sun, 28 Feb 2021 21:04:43 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN> <xjfft1he31v.fsf@HIDDEN>
 <86wnut8fb9.fsf@HIDDEN> <861rd1tbpa.fsf@HIDDEN>
Date: Sun, 28 Feb 2021 21:04:43 +0000
In-Reply-To: <861rd1tbpa.fsf@HIDDEN> (Andy Moreton's message of "Sat, 27
 Feb 2021 21:58:25 +0000")
Message-ID: <xjfv9abdhuc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256-done
Cc: 46256-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andy Moreton <andrewjmoreton@HIDDEN> writes:

> On Sat 27 Feb 2021, Andy Moreton wrote:
>
>> On Sat 27 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>
>>> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>>>> There are still some elisp files that did not get native compiled when
>>>> the build was done with "make -j8 NATIVE_FULL_AOT=1", and so get async
>>>> compiled when running the built emacs:
>>>>
>>>>   ansi-color auth_source byte-opt bytecomp cconv cl-extra cl-lib cl-macs
>>>>   cl-seq comint comp comp-cstr cus-edit cus-start desktop
>>>>   display-fill-column-indicator easy-mmode easymenu edmacro eieio
>>>>   eieio-core frameset gv help-mode hl-line image-file info json kmacro
>>>>   map minibuf-eldef package paren password-cache pcase pp ring rx seq
>>>>   subr-x time-date warnings wid-edit
>>>>
>>>> That may be a result of the error during the build.
>>>
>>> Mmmmh, that's strange some of these are even compiled as COMPILE_FIRST
>>> therfore are certainly native compiled.
>>
>> I suspect that the issue may be with parallel builds (note the "-j8"
>> above). Repeating the build with "-j1" appears to be building the
>> missing .eln files as expected.
>
> Now that the -j1 build has completed (without error), all of the lisp
> files have been compiled AOT as expected, and running the resulting
> emacs does not rebuild any of those .eln files.
>
> So I think there are still some other issues with dependencies and
> handling parallel builds, but this bug has been fixed.

Thanks for checking, I'm closing then.

  Andrea




Notification sent to Andy Moreton <andrewjmoreton@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Andrea Corallo <akrl@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 28 Feb 2021 17:35:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 28 12:35:54 2021
Received: from localhost ([127.0.0.1]:47127 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lGPyz-0007Yz-Vq
	for submit <at> debbugs.gnu.org; Sun, 28 Feb 2021 12:35:54 -0500
Received: from eggs.gnu.org ([209.51.188.92]:51844)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lGPyy-0007Yn-GK
 for 46256 <at> debbugs.gnu.org; Sun, 28 Feb 2021 12:35:52 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53147)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lGPyo-000486-Dh; Sun, 28 Feb 2021 12:35:43 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3795
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lGPyS-00028T-EM; Sun, 28 Feb 2021 12:35:24 -0500
Date: Sun, 28 Feb 2021 19:35:16 +0200
Message-Id: <83pn0km6y3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
In-Reply-To: <861rd1tbpa.fsf@HIDDEN> (message from Andy Moreton on Sat, 27
 Feb 2021 21:58:25 +0000)
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run from
 build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN> <xjfft1he31v.fsf@HIDDEN>
 <86wnut8fb9.fsf@HIDDEN> <861rd1tbpa.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andy Moreton <andrewjmoreton@HIDDEN>
> Date: Sat, 27 Feb 2021 21:58:25 +0000
> 
> > I suspect that the issue may be with parallel builds (note the "-j8"
> > above). Repeating the build with "-j1" appears to be building the
> > missing .eln files as expected.
> 
> Now that the -j1 build has completed (without error), all of the lisp
> files have been compiled AOT as expected, and running the resulting
> emacs does not rebuild any of those .eln files.
> 
> So I think there are still some other issues with dependencies and
> handling parallel builds, but this bug has been fixed.

Hmm... what would be the reason for parallel builds not work well on
MS-Windows? file sharing issues?

Does the async native compilation use temporary files, and if so, do
they reside in the same directory when multiple compilations are
running?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 27 Feb 2021 21:58:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 27 16:58:38 2021
Received: from localhost ([127.0.0.1]:45503 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lG7bi-0000MF-52
	for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 16:58:38 -0500
Received: from lists.gnu.org ([209.51.188.17]:56274)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lG7bg-0000M8-UL
 for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 16:58:37 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:41758)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lG7bf-0003Qb-6T
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 16:58:35 -0500
Received: from ciao.gmane.io ([116.202.254.214]:47124)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lG7bc-0006dJ-Om
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 16:58:34 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lG7ba-0004Pf-5P
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 22:58:30 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
Date: Sat, 27 Feb 2021 21:58:25 +0000
Message-ID: <861rd1tbpa.fsf@HIDDEN>
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN> <xjfft1he31v.fsf@HIDDEN>
 <86wnut8fb9.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:cdb+ZYDgt0KA8pd6BQnJyRYfDoM=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.25, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Sat 27 Feb 2021, Andy Moreton wrote:

> On Sat 27 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>
>> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>>> There are still some elisp files that did not get native compiled when
>>> the build was done with "make -j8 NATIVE_FULL_AOT=1", and so get async
>>> compiled when running the built emacs:
>>>
>>>   ansi-color auth_source byte-opt bytecomp cconv cl-extra cl-lib cl-macs
>>>   cl-seq comint comp comp-cstr cus-edit cus-start desktop
>>>   display-fill-column-indicator easy-mmode easymenu edmacro eieio
>>>   eieio-core frameset gv help-mode hl-line image-file info json kmacro
>>>   map minibuf-eldef package paren password-cache pcase pp ring rx seq
>>>   subr-x time-date warnings wid-edit
>>>
>>> That may be a result of the error during the build.
>>
>> Mmmmh, that's strange some of these are even compiled as COMPILE_FIRST
>> therfore are certainly native compiled.
>
> I suspect that the issue may be with parallel builds (note the "-j8"
> above). Repeating the build with "-j1" appears to be building the
> missing .eln files as expected.

Now that the -j1 build has completed (without error), all of the lisp
files have been compiled AOT as expected, and running the resulting
emacs does not rebuild any of those .eln files.

So I think there are still some other issues with dependencies and
handling parallel builds, but this bug has been fixed.

Thanks,

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 27 Feb 2021 19:46:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 27 14:46:15 2021
Received: from localhost ([127.0.0.1]:45428 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lG5Xb-0005ht-4L
	for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 14:46:15 -0500
Received: from lists.gnu.org ([209.51.188.17]:45782)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lG5XZ-0005hl-1m
 for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 14:46:13 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:51038)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lG5XY-00008T-Nq
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 14:46:12 -0500
Received: from ciao.gmane.io ([116.202.254.214]:53806)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lG5XX-0006wz-D0
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 14:46:12 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lG5XU-000A4P-E9
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 20:46:08 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
Date: Sat, 27 Feb 2021 19:46:02 +0000
Message-ID: <86wnut8fb9.fsf@HIDDEN>
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN> <xjfft1he31v.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:/Uu+llnaFnDLEE3+gbGHfxojOc8=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.25, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Sat 27 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:

> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>> There are still some elisp files that did not get native compiled when
>> the build was done with "make -j8 NATIVE_FULL_AOT=1", and so get async
>> compiled when running the built emacs:
>>
>>   ansi-color auth_source byte-opt bytecomp cconv cl-extra cl-lib cl-macs
>>   cl-seq comint comp comp-cstr cus-edit cus-start desktop
>>   display-fill-column-indicator easy-mmode easymenu edmacro eieio
>>   eieio-core frameset gv help-mode hl-line image-file info json kmacro
>>   map minibuf-eldef package paren password-cache pcase pp ring rx seq
>>   subr-x time-date warnings wid-edit
>>
>> That may be a result of the error during the build.
>
> Mmmmh, that's strange some of these are even compiled as COMPILE_FIRST
> therfore are certainly native compiled.

I suspect that the issue may be with parallel builds (note the "-j8"
above). Repeating the build with "-j1" appears to be building the
missing .eln files as expected.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 27 Feb 2021 19:20:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 27 14:20:28 2021
Received: from localhost ([127.0.0.1]:45413 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lG58e-00056t-6F
	for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 14:20:28 -0500
Received: from mx.sdf.org ([205.166.94.24]:65238)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lG58b-00056j-Lp
 for 46256 <at> debbugs.gnu.org; Sat, 27 Feb 2021 14:20:26 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11RJKOKk015805
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sat, 27 Feb 2021 19:20:24 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN> <xjfft1he31v.fsf@HIDDEN>
Date: Sat, 27 Feb 2021 19:20:24 +0000
In-Reply-To: <xjfft1he31v.fsf@HIDDEN> (Andrea Corallo via's message of "Sat, 
 27 Feb 2021 19:14:20 +0000")
Message-ID: <xjfblc5e2rr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, Andy Moreton <andrewjmoreton@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" <bug-gnu-emacs@HIDDEN> writes:

> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>
>> On Fri 26 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>
>>> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>>>
>>> [...]
>>>
>>>> The problem is with the file names used to generate the hashes, where
>>>> comparison of file names.
>>>>
>>>> As an experiment, I changed epaths.h from:
>>>> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>>>>
>>>> to:
>>>> #define PATH_DUMPLOADSEARCH "c:/emacs/git/emacs/native/lisp"
>>>>
>>>> and then ran make (to build without regenerating the header).
>>>> The resulting emacs did not complain about mismatched filenames.
>>>>
>>>> Thus the fix outlined by Eli above looks like it will solve the problem.
>>>>
>>>>     AndyM
>>>
>>> Hi Andy,
>>>
>>> could you give it a try to the attached patch?  It follows Eli's
>>> suggestion of using 'Fw32_long_file_name'.
>>
>> The patch looks good - please apply it.
>
> Thanks for verifying it, installed as 312deba530.
>
>> I tried building with the patch applied to a clean tree, and the
>> resulting emacs runs without the filename mismatch messages, and did not
>> recompile the AOT files into the per-user eln-cache.
>>
>> There were also a couple of errors in the build:
>>
>> Backtrace:
>> 00007ff78467a2a2
>> 00007ff78453be26
>> 00007ff7845a98ac
>> ...[snipped]...
>> 00007ff784626548
>> Eager macro-expansion failure: (file-error "Renaming" "Permission
>> denied"
>> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2-native/native-lisp/28.0.50-e09cfb99/cc-bytecomp-4817e810-d16f606e.eln"
>> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2-native/native-lisp/28.0.50-e09cfb99/cc-bytecomp-4817e810-d16f606e.elnGMMUdn.eln.tmp")
>> C:/emacs/git/emacs/native/src/alloc.c:3160: Emacs fatal error: assertion failed: cu->handle
>> make[2]: *** [Makefile:319: progmodes/antlr-mode.elc] Error 3
>>
>> The backtrace addresses did not give anything useful from addr2line.
>>
>> There are still some elisp files that did not get native compiled when
>> the build was done with "make -j8 NATIVE_FULL_AOT=1", and so get async
>> compiled when running the built emacs:
>>
>>   ansi-color auth_source byte-opt bytecomp cconv cl-extra cl-lib cl-macs
>>   cl-seq comint comp comp-cstr cus-edit cus-start desktop
>>   display-fill-column-indicator easy-mmode easymenu edmacro eieio
>>   eieio-core frameset gv help-mode hl-line image-file info json kmacro
>>   map minibuf-eldef package paren password-cache pcase pp ring rx seq
>>   subr-x time-date warnings wid-edit
>>
>> That may be a result of the error during the build.
>
> Mmmmh, that's strange some of these are even compiled as COMPILE_FIRST
> therfore are certainly native compiled.
>
> One thing you could do (before one of these is recompiled) is to use
> `comp-el-to-eln-filename' to check what the native compiler is expecting
> as eln filename and if this is present in any of the folders in your
> `comp-eln-load-path'.

Apologies, to be more precise: if the file is compiled during the build
(as should be in this case) it should be in the "native-lisp/" dir in
the build tree.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 27 Feb 2021 19:20:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 27 14:20:37 2021
Received: from localhost ([127.0.0.1]:45416 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lG58n-00057F-HT
	for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 14:20:37 -0500
Received: from lists.gnu.org ([209.51.188.17]:43038)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lG58m-000577-HQ
 for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 14:20:37 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:48334)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1lG58h-0004gN-E1
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 14:20:35 -0500
Received: from mx.sdf.org ([205.166.94.24]:65236)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <akrl@HIDDEN>) id 1lG58d-0003fs-P0
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 14:20:31 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11RJKOKk015805
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sat, 27 Feb 2021 19:20:24 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
 text editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN> <xjfft1he31v.fsf@HIDDEN>
Date: Sat, 27 Feb 2021 19:20:24 +0000
In-Reply-To: <xjfft1he31v.fsf@HIDDEN> (Andrea Corallo via's message of "Sat, 
 27 Feb 2021 19:14:20 +0000")
Message-ID: <xjfblc5e2rr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=205.166.94.24; envelope-from=akrl@HIDDEN;
 helo=mx.sdf.org
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: 46256 <at> debbugs.gnu.org, Andy Moreton <andrewjmoreton@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
text editors" <bug-gnu-emacs@HIDDEN> writes:

> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>
>> On Fri 26 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>
>>> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>>>
>>> [...]
>>>
>>>> The problem is with the file names used to generate the hashes, where
>>>> comparison of file names.
>>>>
>>>> As an experiment, I changed epaths.h from:
>>>> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>>>>
>>>> to:
>>>> #define PATH_DUMPLOADSEARCH "c:/emacs/git/emacs/native/lisp"
>>>>
>>>> and then ran make (to build without regenerating the header).
>>>> The resulting emacs did not complain about mismatched filenames.
>>>>
>>>> Thus the fix outlined by Eli above looks like it will solve the problem.
>>>>
>>>>     AndyM
>>>
>>> Hi Andy,
>>>
>>> could you give it a try to the attached patch?  It follows Eli's
>>> suggestion of using 'Fw32_long_file_name'.
>>
>> The patch looks good - please apply it.
>
> Thanks for verifying it, installed as 312deba530.
>
>> I tried building with the patch applied to a clean tree, and the
>> resulting emacs runs without the filename mismatch messages, and did not
>> recompile the AOT files into the per-user eln-cache.
>>
>> There were also a couple of errors in the build:
>>
>> Backtrace:
>> 00007ff78467a2a2
>> 00007ff78453be26
>> 00007ff7845a98ac
>> ...[snipped]...
>> 00007ff784626548
>> Eager macro-expansion failure: (file-error "Renaming" "Permission
>> denied"
>> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2-native/native-lisp/28.0.50-e09cfb99/cc-bytecomp-4817e810-d16f606e.eln"
>> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2-native/native-lisp/28.0.50-e09cfb99/cc-bytecomp-4817e810-d16f606e.elnGMMUdn.eln.tmp")
>> C:/emacs/git/emacs/native/src/alloc.c:3160: Emacs fatal error: assertion failed: cu->handle
>> make[2]: *** [Makefile:319: progmodes/antlr-mode.elc] Error 3
>>
>> The backtrace addresses did not give anything useful from addr2line.
>>
>> There are still some elisp files that did not get native compiled when
>> the build was done with "make -j8 NATIVE_FULL_AOT=1", and so get async
>> compiled when running the built emacs:
>>
>>   ansi-color auth_source byte-opt bytecomp cconv cl-extra cl-lib cl-macs
>>   cl-seq comint comp comp-cstr cus-edit cus-start desktop
>>   display-fill-column-indicator easy-mmode easymenu edmacro eieio
>>   eieio-core frameset gv help-mode hl-line image-file info json kmacro
>>   map minibuf-eldef package paren password-cache pcase pp ring rx seq
>>   subr-x time-date warnings wid-edit
>>
>> That may be a result of the error during the build.
>
> Mmmmh, that's strange some of these are even compiled as COMPILE_FIRST
> therfore are certainly native compiled.
>
> One thing you could do (before one of these is recompiled) is to use
> `comp-el-to-eln-filename' to check what the native compiler is expecting
> as eln filename and if this is present in any of the folders in your
> `comp-eln-load-path'.

Apologies, to be more precise: if the file is compiled during the build
(as should be in this case) it should be in the "native-lisp/" dir in
the build tree.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 27 Feb 2021 19:14:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 27 14:14:26 2021
Received: from localhost ([127.0.0.1]:45408 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lG52o-0004xx-EK
	for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 14:14:26 -0500
Received: from mx.sdf.org ([205.166.94.24]:49159)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lG52l-0004xk-Hc
 for 46256 <at> debbugs.gnu.org; Sat, 27 Feb 2021 14:14:25 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11RJEKF0017330
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sat, 27 Feb 2021 19:14:21 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <86wnutogrh.fsf@HIDDEN>
Date: Sat, 27 Feb 2021 19:14:20 +0000
In-Reply-To: <86wnutogrh.fsf@HIDDEN> (Andy Moreton's message of "Sat, 27
 Feb 2021 12:08:02 +0000")
Message-ID: <xjfft1he31v.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andy Moreton <andrewjmoreton@HIDDEN> writes:

> On Fri 26 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>
>> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>>
>> [...]
>>
>>> The problem is with the file names used to generate the hashes, where
>>> comparison of file names.
>>>
>>> As an experiment, I changed epaths.h from:
>>> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>>>
>>> to:
>>> #define PATH_DUMPLOADSEARCH "c:/emacs/git/emacs/native/lisp"
>>>
>>> and then ran make (to build without regenerating the header).
>>> The resulting emacs did not complain about mismatched filenames.
>>>
>>> Thus the fix outlined by Eli above looks like it will solve the problem.
>>>
>>>     AndyM
>>
>> Hi Andy,
>>
>> could you give it a try to the attached patch?  It follows Eli's
>> suggestion of using 'Fw32_long_file_name'.
>
> The patch looks good - please apply it.

Thanks for verifying it, installed as 312deba530.

> I tried building with the patch applied to a clean tree, and the
> resulting emacs runs without the filename mismatch messages, and did not
> recompile the AOT files into the per-user eln-cache.
>
> There were also a couple of errors in the build:
>
> Backtrace:
> 00007ff78467a2a2
> 00007ff78453be26
> 00007ff7845a98ac
> ...[snipped]...
> 00007ff784626548
> Eager macro-expansion failure: (file-error "Renaming" "Permission
> denied"
> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2-native/native-lisp/28.0.50-e09cfb99/cc-bytecomp-4817e810-d16f606e.eln"
> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2-native/native-lisp/28.0.50-e09cfb99/cc-bytecomp-4817e810-d16f606e.elnGMMUdn.eln.tmp")
> C:/emacs/git/emacs/native/src/alloc.c:3160: Emacs fatal error: assertion failed: cu->handle
> make[2]: *** [Makefile:319: progmodes/antlr-mode.elc] Error 3
>
> The backtrace addresses did not give anything useful from addr2line.
>
> There are still some elisp files that did not get native compiled when
> the build was done with "make -j8 NATIVE_FULL_AOT=1", and so get async
> compiled when running the built emacs:
>
>   ansi-color auth_source byte-opt bytecomp cconv cl-extra cl-lib cl-macs
>   cl-seq comint comp comp-cstr cus-edit cus-start desktop
>   display-fill-column-indicator easy-mmode easymenu edmacro eieio
>   eieio-core frameset gv help-mode hl-line image-file info json kmacro
>   map minibuf-eldef package paren password-cache pcase pp ring rx seq
>   subr-x time-date warnings wid-edit
>
> That may be a result of the error during the build.

Mmmmh, that's strange some of these are even compiled as COMPILE_FIRST
therfore are certainly native compiled.

One thing you could do (before one of these is recompiled) is to use
`comp-el-to-eln-filename' to check what the native compiler is expecting
as eln filename and if this is present in any of the folders in your
`comp-eln-load-path'.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 27 Feb 2021 12:08:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 27 07:08:16 2021
Received: from localhost ([127.0.0.1]:43310 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lFyOO-0004d5-7P
	for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 07:08:16 -0500
Received: from lists.gnu.org ([209.51.188.17]:40004)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lFyOM-0004cy-OS
 for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 07:08:15 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:33178)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lFyOM-0007fH-K0
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 07:08:14 -0500
Received: from ciao.gmane.io ([116.202.254.214]:44984)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lFyOL-0001fm-As
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 07:08:14 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lFyOI-00016d-IV
 for bug-gnu-emacs@HIDDEN; Sat, 27 Feb 2021 13:08:10 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
Date: Sat, 27 Feb 2021 12:08:02 +0000
Message-ID: <86wnutogrh.fsf@HIDDEN>
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:q7yvs+GpnN5iWxhXB62Xj7rnX1I=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.25, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Fri 26 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:

> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>
> [...]
>
>> The problem is with the file names used to generate the hashes, where
>> comparison of file names.
>>
>> As an experiment, I changed epaths.h from:
>> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>>
>> to:
>> #define PATH_DUMPLOADSEARCH "c:/emacs/git/emacs/native/lisp"
>>
>> and then ran make (to build without regenerating the header).
>> The resulting emacs did not complain about mismatched filenames.
>>
>> Thus the fix outlined by Eli above looks like it will solve the problem.
>>
>>     AndyM
>
> Hi Andy,
>
> could you give it a try to the attached patch?  It follows Eli's
> suggestion of using 'Fw32_long_file_name'.

The patch looks good - please apply it.

I tried building with the patch applied to a clean tree, and the
resulting emacs runs without the filename mismatch messages, and did not
recompile the AOT files into the per-user eln-cache.

There were also a couple of errors in the build:

Backtrace:
00007ff78467a2a2
00007ff78453be26
00007ff7845a98ac
...[snipped]...
00007ff784626548
Eager macro-expansion failure: (file-error "Renaming" "Permission
denied"
"c:/emacs/git/emacs/native/build/mingw64-x86_64-O2-native/native-lisp/28.0.50-e09cfb99/cc-bytecomp-4817e810-d16f606e.eln"
"c:/emacs/git/emacs/native/build/mingw64-x86_64-O2-native/native-lisp/28.0.50-e09cfb99/cc-bytecomp-4817e810-d16f606e.elnGMMUdn.eln.tmp")
C:/emacs/git/emacs/native/src/alloc.c:3160: Emacs fatal error: assertion failed: cu->handle
make[2]: *** [Makefile:319: progmodes/antlr-mode.elc] Error 3

The backtrace addresses did not give anything useful from addr2line.

There are still some elisp files that did not get native compiled when
the build was done with "make -j8 NATIVE_FULL_AOT=1", and so get async
compiled when running the built emacs:

  ansi-color auth_source byte-opt bytecomp cconv cl-extra cl-lib cl-macs
  cl-seq comint comp comp-cstr cus-edit cus-start desktop
  display-fill-column-indicator easy-mmode easymenu edmacro eieio
  eieio-core frameset gv help-mode hl-line image-file info json kmacro
  map minibuf-eldef package paren password-cache pcase pp ring rx seq
  subr-x time-date warnings wid-edit

That may be a result of the error during the build.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 27 Feb 2021 07:55:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 27 02:55:18 2021
Received: from localhost ([127.0.0.1]:43135 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lFuRa-0006ru-Cb
	for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 02:55:18 -0500
Received: from eggs.gnu.org ([209.51.188.92]:40876)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lFuRY-0006rd-Ie
 for 46256 <at> debbugs.gnu.org; Sat, 27 Feb 2021 02:55:17 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:56763)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lFuRT-0000kv-Am; Sat, 27 Feb 2021 02:55:11 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2120
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lFuRS-0003sP-MP; Sat, 27 Feb 2021 02:55:11 -0500
Date: Sat, 27 Feb 2021 09:55:02 +0200
Message-Id: <834khyosh5.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfk0qudmje.fsf@HIDDEN> (message from Andrea Corallo on Sat, 27
 Feb 2021 06:58:45 +0000)
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <83k0qupnhc.fsf@HIDDEN> <xjfo8g6eerv.fsf@HIDDEN>
 <83im6epn58.fsf@HIDDEN> <xjfk0qudmje.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, andrewjmoreton@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: andrewjmoreton@HIDDEN, 46256 <at> debbugs.gnu.org
> Date: Sat, 27 Feb 2021 06:58:45 +0000
> 
> Nice, thinking about I've got a last question: normalizing "c:/foo/" the
> trainling '/' is kept or removed?  If the case is the second the patch
> needs an adjustment.

A single trailing slash, if any, is kept.  Multiple trailing slashes
are collapsed into a single one.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 27 Feb 2021 06:58:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 27 01:58:50 2021
Received: from localhost ([127.0.0.1]:43096 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lFtYv-0005Rn-TX
	for submit <at> debbugs.gnu.org; Sat, 27 Feb 2021 01:58:50 -0500
Received: from mx.sdf.org ([205.166.94.24]:61699)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lFtYt-0005Rc-DA
 for 46256 <at> debbugs.gnu.org; Sat, 27 Feb 2021 01:58:48 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11R6wjX8029002
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sat, 27 Feb 2021 06:58:46 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <83k0qupnhc.fsf@HIDDEN> <xjfo8g6eerv.fsf@HIDDEN>
 <83im6epn58.fsf@HIDDEN>
Date: Sat, 27 Feb 2021 06:58:45 +0000
In-Reply-To: <83im6epn58.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 26 Feb
 2021 22:52:35 +0200")
Message-ID: <xjfk0qudmje.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, andrewjmoreton@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: andrewjmoreton@HIDDEN, 46256 <at> debbugs.gnu.org
>> Date: Fri, 26 Feb 2021 20:48:52 +0000
>> 
>> Quick question: I assumed Fw32_long_file_name works for directories as
>> well, is this correct?
>
> Yes, it does.

Nice, thinking about I've got a last question: normalizing "c:/foo/" the
trainling '/' is kept or removed?  If the case is the second the patch
needs an adjustment.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 26 Feb 2021 20:52:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 26 15:52:53 2021
Received: from localhost ([127.0.0.1]:42675 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lFk6W-0005jO-Sh
	for submit <at> debbugs.gnu.org; Fri, 26 Feb 2021 15:52:53 -0500
Received: from eggs.gnu.org ([209.51.188.92]:39862)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lFk6V-0005jC-Jy
 for 46256 <at> debbugs.gnu.org; Fri, 26 Feb 2021 15:52:51 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42011)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lFk6Q-0006Ql-8p; Fri, 26 Feb 2021 15:52:46 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1407
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lFk6P-00044O-K1; Fri, 26 Feb 2021 15:52:46 -0500
Date: Fri, 26 Feb 2021 22:52:35 +0200
Message-Id: <83im6epn58.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfo8g6eerv.fsf@HIDDEN> (message from Andrea Corallo on Fri, 26
 Feb 2021 20:48:52 +0000)
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <83k0qupnhc.fsf@HIDDEN> <xjfo8g6eerv.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, andrewjmoreton@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: andrewjmoreton@HIDDEN, 46256 <at> debbugs.gnu.org
> Date: Fri, 26 Feb 2021 20:48:52 +0000
> 
> Quick question: I assumed Fw32_long_file_name works for directories as
> well, is this correct?

Yes, it does.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 26 Feb 2021 20:48:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 26 15:48:54 2021
Received: from localhost ([127.0.0.1]:42669 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lFk2g-0005de-Ca
	for submit <at> debbugs.gnu.org; Fri, 26 Feb 2021 15:48:54 -0500
Received: from mx.sdf.org ([205.166.94.24]:63070)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lFk2f-0005dX-HV
 for 46256 <at> debbugs.gnu.org; Fri, 26 Feb 2021 15:48:54 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11QKmqUF023479
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 26 Feb 2021 20:48:53 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
 <83k0qupnhc.fsf@HIDDEN>
Date: Fri, 26 Feb 2021 20:48:52 +0000
In-Reply-To: <83k0qupnhc.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 26 Feb
 2021 22:45:19 +0200")
Message-ID: <xjfo8g6eerv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, andrewjmoreton@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Cc: 46256 <at> debbugs.gnu.org
>> Date: Fri, 26 Feb 2021 20:34:10 +0000
>> From:  Andrea Corallo via "Bug reports for GNU Emacs,
>>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
>> 
>> --- a/src/comp.c
>> +++ b/src/comp.c
>> @@ -3983,6 +3983,10 @@ DEFUN ("comp-el-to-eln-filename", Fcomp_el_to_eln_filename,
>>    if (NILP (Ffile_exists_p (filename)))
>>      xsignal1 (Qfile_missing, filename);
>>  
>> +#ifdef WINDOWSNT
>> +  filename = Fw32_long_file_name (filename);
>> +#endif
>
> Is "filename" here a name of an existing file?  If not,
> Fw32_long_file_name will return nil.

It should always be as we explicitly check for that.

Quick question: I assumed Fw32_long_file_name works for directories as
well, is this correct?

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 26 Feb 2021 20:45:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 26 15:45:41 2021
Received: from localhost ([127.0.0.1]:42665 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lFjzY-0005Z0-Ra
	for submit <at> debbugs.gnu.org; Fri, 26 Feb 2021 15:45:41 -0500
Received: from eggs.gnu.org ([209.51.188.92]:37830)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lFjzX-0005Yo-4K
 for 46256 <at> debbugs.gnu.org; Fri, 26 Feb 2021 15:45:39 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:41850)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lFjzR-0003FJ-QY; Fri, 26 Feb 2021 15:45:33 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4938
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lFjzP-0003Ot-W7; Fri, 26 Feb 2021 15:45:32 -0500
Date: Fri, 26 Feb 2021 22:45:19 +0200
Message-Id: <83k0qupnhc.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfwnuuefgd.fsf@HIDDEN> (bug-gnu-emacs@HIDDEN)
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run from
 build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN> <xjfwnuuefgd.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, andrewjmoreton@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Cc: 46256 <at> debbugs.gnu.org
> Date: Fri, 26 Feb 2021 20:34:10 +0000
> From:  Andrea Corallo via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> 
> --- a/src/comp.c
> +++ b/src/comp.c
> @@ -3983,6 +3983,10 @@ DEFUN ("comp-el-to-eln-filename", Fcomp_el_to_eln_filename,
>    if (NILP (Ffile_exists_p (filename)))
>      xsignal1 (Qfile_missing, filename);
>  
> +#ifdef WINDOWSNT
> +  filename = Fw32_long_file_name (filename);
> +#endif

Is "filename" here a name of an existing file?  If not,
Fw32_long_file_name will return nil.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 26 Feb 2021 20:34:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 26 15:34:19 2021
Received: from localhost ([127.0.0.1]:42645 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lFjoV-0005Ha-3Y
	for submit <at> debbugs.gnu.org; Fri, 26 Feb 2021 15:34:18 -0500
Received: from mx.sdf.org ([205.166.94.24]:64014)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lFjoS-0005HR-Lc
 for 46256 <at> debbugs.gnu.org; Fri, 26 Feb 2021 15:34:13 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11QKYAap007081
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 26 Feb 2021 20:34:11 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN>
Date: Fri, 26 Feb 2021 20:34:10 +0000
In-Reply-To: <86v9ao5czu.fsf@HIDDEN> (Andy Moreton's message of "Fri, 19
 Feb 2021 14:49:25 +0000")
Message-ID: <xjfwnuuefgd.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Andy Moreton <andrewjmoreton@HIDDEN> writes:

[...]

> The problem is with the file names used to generate the hashes, where
> comparison of file names.
>
> As an experiment, I changed epaths.h from:
> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>
> to:
> #define PATH_DUMPLOADSEARCH "c:/emacs/git/emacs/native/lisp"
>
> and then ran make (to build without regenerating the header).
> The resulting emacs did not complain about mismatched filenames.
>
> Thus the fix outlined by Eli above looks like it will solve the problem.
>
>     AndyM

Hi Andy,

could you give it a try to the attached patch?  It follows Eli's
suggestion of using 'Fw32_long_file_name'.

Thanks

  Andrea

--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-Canonicalize-filenames-on-Windows-before-hashing-bug.patch

From 312deba5302a8136fa104b054af54572cc64ea5e Mon Sep 17 00:00:00 2001
From: Andrea Corallo <akrl@HIDDEN>
Date: Fri, 26 Feb 2021 21:27:02 +0100
Subject: [PATCH] * Canonicalize filenames on Windows before hashing
 (bug#46256)

	* src/comp.c (Fcomp_el_to_eln_filename): On Windowns
	canonicalize filenames before hashing.
---
 src/comp.c | 11 +++++++++--
 1 file changed, 9 insertions(+), 2 deletions(-)

diff --git a/src/comp.c b/src/comp.c
index a8b8ef95fa..1a89e4e62a 100644
--- a/src/comp.c
+++ b/src/comp.c
@@ -3983,6 +3983,10 @@ DEFUN ("comp-el-to-eln-filename", Fcomp_el_to_eln_filename,
   if (NILP (Ffile_exists_p (filename)))
     xsignal1 (Qfile_missing, filename);
 
+#ifdef WINDOWSNT
+  filename = Fw32_long_file_name (filename);
+#endif
+
   Lisp_Object content_hash = comp_hash_source_file (filename);
 
   if (suffix_p (filename, ".gz"))
@@ -4014,8 +4018,11 @@ DEFUN ("comp-el-to-eln-filename", Fcomp_el_to_eln_filename,
       Lisp_Object sys_re =
 	concat2 (build_string ("\\`[[:ascii:]]+"),
 		 Fregexp_quote (build_string ("/" PATH_REL_LOADSEARCH "/")));
-      loadsearch_re_list =
-	list2 (sys_re, Fregexp_quote (build_string (PATH_DUMPLOADSEARCH "/")));
+      Lisp_Object dump_load_search = build_string (PATH_DUMPLOADSEARCH "/");
+#ifdef WINDOWSNT
+      dump_load_search = Fw32_long_file_name (dump_load_search);
+#endif
+      loadsearch_re_list = list2 (sys_re, Fregexp_quote (dump_load_search));
     }
 
   Lisp_Object lds_re_tail = loadsearch_re_list;
-- 
2.20.1


--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 19 Feb 2021 16:01:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 11:01:05 2021
Received: from localhost ([127.0.0.1]:50212 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD8DI-0007aJ-Tk
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 11:01:05 -0500
Received: from mx.sdf.org ([205.166.94.24]:63336)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lD8DG-0007Zf-5w
 for 46256 <at> debbugs.gnu.org; Fri, 19 Feb 2021 11:01:04 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11JG11FH000872
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 19 Feb 2021 16:01:01 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
 <86v9ao5czu.fsf@HIDDEN>
Date: Fri, 19 Feb 2021 16:01:01 +0000
In-Reply-To: <86v9ao5czu.fsf@HIDDEN> (Andy Moreton's message of "Fri, 19
 Feb 2021 14:49:25 +0000")
Message-ID: <xjfft1sm4hu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andy Moreton <andrewjmoreton@HIDDEN> writes:

> As an experiment, I changed epaths.h from:
> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>
> to:
> #define PATH_DUMPLOADSEARCH "c:/emacs/git/emacs/native/lisp"
>
> and then ran make (to build without regenerating the header).
> The resulting emacs did not complain about mismatched filenames.
>
> Thus the fix outlined by Eli above looks like it will solve the problem.

Sounds great!

I'll write the fix in the following days (in case somebody wants to take
over the task just mention it here, indeed this is very welcome).

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 19 Feb 2021 15:28:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 10:28:38 2021
Received: from localhost ([127.0.0.1]:50160 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD7ht-0004eK-Ue
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 10:28:38 -0500
Received: from eggs.gnu.org ([209.51.188.92]:54018)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lD7hp-0004e2-Jk
 for 46256 <at> debbugs.gnu.org; Fri, 19 Feb 2021 10:28:36 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50613)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lD7hk-0003gc-DS; Fri, 19 Feb 2021 10:28:28 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1074
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lD7hj-0005Kq-9P; Fri, 19 Feb 2021 10:28:28 -0500
Date: Fri, 19 Feb 2021 17:28:41 +0200
Message-Id: <835z2o2i1i.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
In-Reply-To: <86v9ao5czu.fsf@HIDDEN> (message from Andy Moreton on Fri, 19
 Feb 2021 14:49:25 +0000)
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run from
 build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN> <86v9ao5czu.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andy Moreton <andrewjmoreton@HIDDEN>
> Date: Fri, 19 Feb 2021 14:49:25 +0000
> 
> As an experiment, I changed epaths.h from:
> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
> 
> to:
> #define PATH_DUMPLOADSEARCH "c:/emacs/git/emacs/native/lisp"
> 
> and then ran make (to build without regenerating the header).
> The resulting emacs did not complain about mismatched filenames.
> 
> Thus the fix outlined by Eli above looks like it will solve the problem.

Btw, there's a similar in principle, but different in details, problem
with macOS: it stores file names in decomposed form, i.e., for
example,  will be stored as two codepoints: a, followed by U+00A8
DIAERESIS.  So any hashing that relies on comparing file names as
strings will need to normalize the file names on macOS filesystems
(HFS) as well.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 19 Feb 2021 14:49:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 09:49:49 2021
Received: from localhost ([127.0.0.1]:49044 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD76K-0003HC-KX
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 09:49:48 -0500
Received: from lists.gnu.org ([209.51.188.17]:35602)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lD769-0003Go-JP
 for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 09:49:38 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:35078)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lD767-0004ST-ER
 for bug-gnu-emacs@HIDDEN; Fri, 19 Feb 2021 09:49:37 -0500
Received: from ciao.gmane.io ([116.202.254.214]:41748)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lD765-0004c9-IE
 for bug-gnu-emacs@HIDDEN; Fri, 19 Feb 2021 09:49:34 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lD762-0007lS-I8
 for bug-gnu-emacs@HIDDEN; Fri, 19 Feb 2021 15:49:30 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
Date: Fri, 19 Feb 2021 14:49:25 +0000
Message-ID: <86v9ao5czu.fsf@HIDDEN>
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
 <xjfpn0xnlaq.fsf@HIDDEN> <83h7m84h9g.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:AnOx4XS34IABO3NdR70XL6xsZ5E=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Fri 19 Feb 2021, Eli Zaretskii wrote:

>> Cc: 46256 <at> debbugs.gnu.org
>> Date: Thu, 18 Feb 2021 21:00:29 +0000
>> From:  Andrea Corallo via "Bug reports for GNU Emacs,
>>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
>> 
>> >> Last queston: do reverse slashes '\' appear somewhere in those
>> >> filenames?  This was issue I tried to fix with the blind patch I've
>> >> sent.
>> >
>> > As Eli pointed out, that is not the problem: forward slashes are ok.
>> 
>> I understand they are handled, but here as we do a substitution we must
>> substitute what's coming in.
>> 
>> As you have the possibility to debug this piece of code on Windows
>> please have a look at this (or try my blind patch if you haven't).
>
> If the problem is with hashing file names, you will have to
> canonicalize them first, including resolving the letter-case issue,
> the forward/back-slashes issue, and also the issue with those pesky
> numerical tails Windows sometimes produces.  We have a function
> Fw32_long_file_name for that purpose, I think you should use it (if
> you need it for C strings, we could add a wrapper around
> w32_get_long_filename to do that instead).  This assumes that you are
> talking about existing files; if that assumption is not true, we will
> need a slightly different strategy.

The problem is with the file names used to generate the hashes, where
comparison of file names.

As an experiment, I changed epaths.h from:
#define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"

to:
#define PATH_DUMPLOADSEARCH "c:/emacs/git/emacs/native/lisp"

and then ran make (to build without regenerating the header).
The resulting emacs did not complain about mismatched filenames.

Thus the fix outlined by Eli above looks like it will solve the problem.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 19 Feb 2021 08:02:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 19 03:02:28 2021
Received: from localhost ([127.0.0.1]:48662 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lD0k8-0007td-L3
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2021 03:02:28 -0500
Received: from eggs.gnu.org ([209.51.188.92]:35438)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lD0k7-0007tR-MD
 for 46256 <at> debbugs.gnu.org; Fri, 19 Feb 2021 03:02:27 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58364)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lD0k1-0004Zy-RJ; Fri, 19 Feb 2021 03:02:21 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1370
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lD0k0-0002Fv-Ph; Fri, 19 Feb 2021 03:02:21 -0500
Date: Fri, 19 Feb 2021 10:02:35 +0200
Message-Id: <83h7m84h9g.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfpn0xnlaq.fsf@HIDDEN> (bug-gnu-emacs@HIDDEN)
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run from
 build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN> <xjfpn0xnlaq.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, andrewjmoreton@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Cc: 46256 <at> debbugs.gnu.org
> Date: Thu, 18 Feb 2021 21:00:29 +0000
> From:  Andrea Corallo via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> 
> >> Last queston: do reverse slashes '\' appear somewhere in those
> >> filenames?  This was issue I tried to fix with the blind patch I've
> >> sent.
> >
> > As Eli pointed out, that is not the problem: forward slashes are ok.
> 
> I understand they are handled, but here as we do a substitution we must
> substitute what's coming in.
> 
> As you have the possibility to debug this piece of code on Windows
> please have a look at this (or try my blind patch if you haven't).

If the problem is with hashing file names, you will have to
canonicalize them first, including resolving the letter-case issue,
the forward/back-slashes issue, and also the issue with those pesky
numerical tails Windows sometimes produces.  We have a function
Fw32_long_file_name for that purpose, I think you should use it (if
you need it for C strings, we could add a wrapper around
w32_get_long_filename to do that instead).  This assumes that you are
talking about existing files; if that assumption is not true, we will
need a slightly different strategy.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 18 Feb 2021 21:00:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 16:00:32 2021
Received: from localhost ([127.0.0.1]:48236 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCqPY-0005ra-BH
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 16:00:32 -0500
Received: from mx.sdf.org ([205.166.94.24]:50737)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lCqPW-0005on-9u
 for 46256 <at> debbugs.gnu.org; Thu, 18 Feb 2021 16:00:30 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11IL0TgT016730
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 18 Feb 2021 21:00:29 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN> <86blch14qt.fsf@HIDDEN>
Date: Thu, 18 Feb 2021 21:00:29 +0000
In-Reply-To: <86blch14qt.fsf@HIDDEN> (Andy Moreton's message of "Thu, 18
 Feb 2021 20:48:58 +0000")
Message-ID: <xjfpn0xnlaq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andy Moreton <andrewjmoreton@HIDDEN> writes:

> On Wed 17 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>
>> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>>
>>> On Thu 04 Feb 2021, Andy Moreton wrote:
>>>
>>>> On Thu 04 Feb 2021, Andy Moreton wrote:
>>>>
>>>>> On Wed 03 Feb 2021, akrl--- via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>>>>>
>>>>>> Hi Andy,
>>>>>>
>>>>>> could you share the values of PATH_DUMPLOADSEARCH and
>>>>>> PATH_REL_LOADSEARCH from your epaths.h ?
>>>>>>
>>>>>> Thanks
>>>>>>
>>>>>>   Andrea
>>>>>
>>>>> Native branch checkout is in: "c:/emacs/git/emacs/native/"
>>>>>
>>>>> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/src/epaths.h" contains:
>>>>>
>>>>> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>>>>> #define PATH_REL_LOADSEARCH "28.0.50/lisp"
>>>>
>>>> I've bootstrapped again after the recent hash shortening to ensure my build
>>>> is up to date, from commit 1f626e9662d8120acd5a937f847123cc2b8c6e31. The
>>>> paths above are unchanged.
>>>>
>>>> Running this from the build dir, I see messages like:
>>>>
>>>> error in process sentinel: Native elisp load failed: "file does not exists",
>>>>  "c:/home/ajm/.emacs.d/eln-cache/28.0.50-e2ae3598/hl-line-e67628ec-664ef650.eln"
>>>>
>>>> This suggests that the AOT .eln files are not being found. It should find:
>>>>
>>>> c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/native-lisp/28.0.50-e2ae3598/hl-line-8fa29c14-664ef650.eln
>>>>
>>>> The middle hash (e67628ec vs. 8fa29c14) is not the same - any idea why ?
>>>
>>> After looking at what `comp-el-to-eln-filename' does, I observe that:
>>>
>>> (substring (md5 "c:/emacs/git/emacs/native/lisp/hl-line.el") 0 8)
>>> "e67628ec"
>>>
>>> (substring (md5 "//hl-line.el") 0 8)
>>> "8fa29c14"
>>>
>>> That matches the two middle hashes seen above.
>>>
>>> It looks like `comp-el-to-eln-filename` fails to match the filename
>>> prefix against PATH_DUMPLOADSEARCH. It is using case-sensitive matching,
>>> but on Windows filesystems are case-insensitive.
>>
>> Hi Andy,
>>
>> The Windows filesystem is case-insensitive but the case is preserved
>> correct?  If so it should work no?
>
> Yes, Windows filesystems are case-preserving and do case-insensitive
> lookup. The fact the code complains about the file not existing, and the
> hashes matching as described earlier shows it is clearnly not working. I
> have conjectured why, but the reason may well be something else.
>
>> Last queston: do reverse slashes '\' appear somewhere in those
>> filenames?  This was issue I tried to fix with the blind patch I've
>> sent.
>
> As Eli pointed out, that is not the problem: forward slashes are ok.

I understand they are handled, but here as we do a substitution we must
substitute what's coming in.

As you have the possibility to debug this piece of code on Windows
please have a look at this (or try my blind patch if you haven't).

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 18 Feb 2021 20:49:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 18 15:49:10 2021
Received: from localhost ([127.0.0.1]:48204 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCqEY-00053F-Gz
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:49:10 -0500
Received: from lists.gnu.org ([209.51.188.17]:47914)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lCqEX-000538-Hf
 for submit <at> debbugs.gnu.org; Thu, 18 Feb 2021 15:49:09 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:54518)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lCqEX-0006wk-88
 for bug-gnu-emacs@HIDDEN; Thu, 18 Feb 2021 15:49:09 -0500
Received: from ciao.gmane.io ([116.202.254.214]:52776)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lCqEU-00080V-NQ
 for bug-gnu-emacs@HIDDEN; Thu, 18 Feb 2021 15:49:08 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lCqEQ-0005Vx-KO
 for bug-gnu-emacs@HIDDEN; Thu, 18 Feb 2021 21:49:02 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
Date: Thu, 18 Feb 2021 20:48:58 +0000
Message-ID: <86blch14qt.fsf@HIDDEN>
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
 <xjfy2fmpbdr.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:c8RxbaJah94as6kNDVuJWCfLLYw=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.25, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Wed 17 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:

> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>
>> On Thu 04 Feb 2021, Andy Moreton wrote:
>>
>>> On Thu 04 Feb 2021, Andy Moreton wrote:
>>>
>>>> On Wed 03 Feb 2021, akrl--- via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>>>>
>>>>> Hi Andy,
>>>>>
>>>>> could you share the values of PATH_DUMPLOADSEARCH and
>>>>> PATH_REL_LOADSEARCH from your epaths.h ?
>>>>>
>>>>> Thanks
>>>>>
>>>>>   Andrea
>>>>
>>>> Native branch checkout is in: "c:/emacs/git/emacs/native/"
>>>>
>>>> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/src/epaths.h" contains:
>>>>
>>>> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>>>> #define PATH_REL_LOADSEARCH "28.0.50/lisp"
>>>
>>> I've bootstrapped again after the recent hash shortening to ensure my build
>>> is up to date, from commit 1f626e9662d8120acd5a937f847123cc2b8c6e31. The
>>> paths above are unchanged.
>>>
>>> Running this from the build dir, I see messages like:
>>>
>>> error in process sentinel: Native elisp load failed: "file does not exists",
>>>  "c:/home/ajm/.emacs.d/eln-cache/28.0.50-e2ae3598/hl-line-e67628ec-664ef650.eln"
>>>
>>> This suggests that the AOT .eln files are not being found. It should find:
>>>
>>> c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/native-lisp/28.0.50-e2ae3598/hl-line-8fa29c14-664ef650.eln
>>>
>>> The middle hash (e67628ec vs. 8fa29c14) is not the same - any idea why ?
>>
>> After looking at what `comp-el-to-eln-filename' does, I observe that:
>>
>> (substring (md5 "c:/emacs/git/emacs/native/lisp/hl-line.el") 0 8)
>> "e67628ec"
>>
>> (substring (md5 "//hl-line.el") 0 8)
>> "8fa29c14"
>>
>> That matches the two middle hashes seen above.
>>
>> It looks like `comp-el-to-eln-filename` fails to match the filename
>> prefix against PATH_DUMPLOADSEARCH. It is using case-sensitive matching,
>> but on Windows filesystems are case-insensitive.
>
> Hi Andy,
>
> The Windows filesystem is case-insensitive but the case is preserved
> correct?  If so it should work no?

Yes, Windows filesystems are case-preserving and do case-insensitive
lookup. The fact the code complains about the file not existing, and the
hashes matching as described earlier shows it is clearnly not working. I
have conjectured why, but the reason may well be something else.

> Last queston: do reverse slashes '\' appear somewhere in those
> filenames?  This was issue I tried to fix with the blind patch I've
> sent.

As Eli pointed out, that is not the problem: forward slashes are ok.

      AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 17 Feb 2021 22:39:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 17 17:39:32 2021
Received: from localhost ([127.0.0.1]:45329 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lCVTo-0000mB-1v
	for submit <at> debbugs.gnu.org; Wed, 17 Feb 2021 17:39:32 -0500
Received: from mx.sdf.org ([205.166.94.24]:58470)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lCVTl-0000m3-Qa
 for 46256 <at> debbugs.gnu.org; Wed, 17 Feb 2021 17:39:30 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11HMdS9P024973
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Wed, 17 Feb 2021 22:39:29 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <86eehujcip.fsf@HIDDEN>
Date: Wed, 17 Feb 2021 22:39:28 +0000
In-Reply-To: <86eehujcip.fsf@HIDDEN> (Andy Moreton's message of "Fri, 05
 Feb 2021 23:55:10 +0000")
Message-ID: <xjfy2fmpbdr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andy Moreton <andrewjmoreton@HIDDEN> writes:

> On Thu 04 Feb 2021, Andy Moreton wrote:
>
>> On Thu 04 Feb 2021, Andy Moreton wrote:
>>
>>> On Wed 03 Feb 2021, akrl--- via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>>>
>>>> Hi Andy,
>>>>
>>>> could you share the values of PATH_DUMPLOADSEARCH and
>>>> PATH_REL_LOADSEARCH from your epaths.h ?
>>>>
>>>> Thanks
>>>>
>>>>   Andrea
>>>
>>> Native branch checkout is in: "c:/emacs/git/emacs/native/"
>>>
>>> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/src/epaths.h" contains:
>>>
>>> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>>> #define PATH_REL_LOADSEARCH "28.0.50/lisp"
>>
>> I've bootstrapped again after the recent hash shortening to ensure my build
>> is up to date, from commit 1f626e9662d8120acd5a937f847123cc2b8c6e31. The
>> paths above are unchanged.
>>
>> Running this from the build dir, I see messages like:
>>
>> error in process sentinel: Native elisp load failed: "file does not exists",
>>  "c:/home/ajm/.emacs.d/eln-cache/28.0.50-e2ae3598/hl-line-e67628ec-664ef650.eln"
>>
>> This suggests that the AOT .eln files are not being found. It should find:
>>
>> c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/native-lisp/28.0.50-e2ae3598/hl-line-8fa29c14-664ef650.eln
>>
>> The middle hash (e67628ec vs. 8fa29c14) is not the same - any idea why ?
>
> After looking at what `comp-el-to-eln-filename' does, I observe that:
>
> (substring (md5 "c:/emacs/git/emacs/native/lisp/hl-line.el") 0 8)
> "e67628ec"
>
> (substring (md5 "//hl-line.el") 0 8)
> "8fa29c14"
>
> That matches the two middle hashes seen above.
>
> It looks like `comp-el-to-eln-filename` fails to match the filename
> prefix against PATH_DUMPLOADSEARCH. It is using case-sensitive matching,
> but on Windows filesystems are case-insensitive.

Hi Andy,

The Windows filesystem is case-insensitive but the case is preserved
correct?  If so it should work no?

Last queston: do reverse slashes '\' appear somewhere in those
filenames?  This was issue I tried to fix with the blind patch I've
sent.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 5 Feb 2021 23:55:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 05 18:55:23 2021
Received: from localhost ([127.0.0.1]:44857 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l8Awc-0002Eq-KJ
	for submit <at> debbugs.gnu.org; Fri, 05 Feb 2021 18:55:23 -0500
Received: from lists.gnu.org ([209.51.188.17]:49498)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l8Awa-0002Ei-Ot
 for submit <at> debbugs.gnu.org; Fri, 05 Feb 2021 18:55:21 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:40796)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l8Awa-0007Ka-De
 for bug-gnu-emacs@HIDDEN; Fri, 05 Feb 2021 18:55:20 -0500
Received: from ciao.gmane.io ([116.202.254.214]:42764)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l8AwZ-0004IG-0H
 for bug-gnu-emacs@HIDDEN; Fri, 05 Feb 2021 18:55:20 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l8AwW-0005UN-Dd
 for bug-gnu-emacs@HIDDEN; Sat, 06 Feb 2021 00:55:16 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
Date: Fri, 05 Feb 2021 23:55:10 +0000
Message-ID: <86eehujcip.fsf@HIDDEN>
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:kWlhmAkZoP/+HsWVubTO+pAHdCI=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.25, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Thu 04 Feb 2021, Andy Moreton wrote:

> On Thu 04 Feb 2021, Andy Moreton wrote:
>
>> On Wed 03 Feb 2021, akrl--- via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>>
>>> Hi Andy,
>>>
>>> could you share the values of PATH_DUMPLOADSEARCH and
>>> PATH_REL_LOADSEARCH from your epaths.h ?
>>>
>>> Thanks
>>>
>>>   Andrea
>>
>> Native branch checkout is in: "c:/emacs/git/emacs/native/"
>>
>> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/src/epaths.h" contains:
>>
>> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>> #define PATH_REL_LOADSEARCH "28.0.50/lisp"
>
> I've bootstrapped again after the recent hash shortening to ensure my build
> is up to date, from commit 1f626e9662d8120acd5a937f847123cc2b8c6e31. The
> paths above are unchanged.
>
> Running this from the build dir, I see messages like:
>
> error in process sentinel: Native elisp load failed: "file does not exists",
>  "c:/home/ajm/.emacs.d/eln-cache/28.0.50-e2ae3598/hl-line-e67628ec-664ef650.eln"
>
> This suggests that the AOT .eln files are not being found. It should find:
>
> c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/native-lisp/28.0.50-e2ae3598/hl-line-8fa29c14-664ef650.eln
>
> The middle hash (e67628ec vs. 8fa29c14) is not the same - any idea why ?

After looking at what `comp-el-to-eln-filename' does, I observe that:

(substring (md5 "c:/emacs/git/emacs/native/lisp/hl-line.el") 0 8)
"e67628ec"

(substring (md5 "//hl-line.el") 0 8)
"8fa29c14"

That matches the two middle hashes seen above.

It looks like `comp-el-to-eln-filename` fails to match the filename
prefix against PATH_DUMPLOADSEARCH. It is using case-sensitive matching,
but on Windows filesystems are case-insensitive.

    AndyM







Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 5 Feb 2021 20:59:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 05 15:59:48 2021
Received: from localhost ([127.0.0.1]:44717 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l88Ci-0006Va-Lw
	for submit <at> debbugs.gnu.org; Fri, 05 Feb 2021 15:59:48 -0500
Received: from lists.gnu.org ([209.51.188.17]:54996)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l88Ch-0006VT-8A
 for submit <at> debbugs.gnu.org; Fri, 05 Feb 2021 15:59:47 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:38156)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l88Cg-0008VN-VC
 for bug-gnu-emacs@HIDDEN; Fri, 05 Feb 2021 15:59:46 -0500
Received: from ciao.gmane.io ([116.202.254.214]:54160)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l88Cf-0007MQ-L1
 for bug-gnu-emacs@HIDDEN; Fri, 05 Feb 2021 15:59:46 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l88Cc-0001Tk-9n
 for bug-gnu-emacs@HIDDEN; Fri, 05 Feb 2021 21:59:42 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
Date: Fri, 05 Feb 2021 20:59:37 +0000
Message-ID: <86pn1e6xja.fsf@HIDDEN>
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN> <xjfsg6apocy.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:UtgzOH6vzHX0t8eISqqQJ2E+cyQ=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.25, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Fri 05 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:

> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>
>> On Thu 04 Feb 2021, Andy Moreton wrote:
>>
>>> On Wed 03 Feb 2021, akrl--- via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>>>
>>>> Hi Andy,
>>>>
>>>> could you share the values of PATH_DUMPLOADSEARCH and
>>>> PATH_REL_LOADSEARCH from your epaths.h ?
>>>>
>>>> Thanks
>>>>
>>>>   Andrea
>>>
>>> Native branch checkout is in: "c:/emacs/git/emacs/native/"
>>>
>>> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/src/epaths.h" contains:
>>>
>>> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>>> #define PATH_REL_LOADSEARCH "28.0.50/lisp"
>>
>> I've bootstrapped again after the recent hash shortening to ensure my build
>> is up to date, from commit 1f626e9662d8120acd5a937f847123cc2b8c6e31. The
>> paths above are unchanged.
>>
>> Running this from the build dir, I see messages like:
>>
>> error in process sentinel: Native elisp load failed: "file does not exists",
>>  "c:/home/ajm/.emacs.d/eln-cache/28.0.50-e2ae3598/hl-line-e67628ec-664ef650.eln"
>>
>> This suggests that the AOT .eln files are not being found. It should find:
>
> AFAIK you should not get any error but the eln should be recompiled
> automatically.  I guess having updated the hash algorithm the startup is
> failing and you need to clean-up completely the build directory
> (especially native-lisp/), please retry after a git clean -xfd.

All of these experiments are done from a clean tree after "git clean
-xdf", and after removing ~/.emacs.d/eln-cache/*.

>> c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/native-lisp/28.0.50-e2ae3598/hl-line-8fa29c14-664ef650.eln
>>
>> The middle hash (e67628ec vs. 8fa29c14) is not the same - any idea why ?

Also a following obsrvation from this:

a) Initially, the AOT bootstrap creates:
   <build-dir>/native-lisp/28.0.50-e2ae3598/hl-line-8fa29c14-664ef650.eln

b) Running <build-dir>/src/emacs complains about:
   <user-emacs-dir>/eln-cache/28.0.50-e2ae3598/hl-line-e67628ec-664ef650.eln

c) The running emacs then builds:
   ~/.emacs.d/eln-cache/28.0.50-e2ae3598/hl-line-8fa29c14-664ef650.eln

The files (a) and (c) have the same filename, but different sizes and
content.

    AndyM






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 5 Feb 2021 15:08:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 05 10:08:37 2021
Received: from localhost ([127.0.0.1]:44495 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l82ir-0004Ua-CY
	for submit <at> debbugs.gnu.org; Fri, 05 Feb 2021 10:08:37 -0500
Received: from eggs.gnu.org ([209.51.188.92]:59614)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1l82ip-0004UO-Ts
 for 46256 <at> debbugs.gnu.org; Fri, 05 Feb 2021 10:08:36 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46190)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1l82ii-0004nt-CN; Fri, 05 Feb 2021 10:08:28 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4001
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1l82iZ-0004ty-6u; Fri, 05 Feb 2021 10:08:24 -0500
Date: Fri, 05 Feb 2021 17:08:22 +0200
Message-Id: <83blcypn6h.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfwnvmpoht.fsf@HIDDEN> (bug-gnu-emacs@HIDDEN)
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run from
 build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN> <xjfwnvmpoht.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org, andrewjmoreton@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Cc: 46256 <at> debbugs.gnu.org
> Date: Fri, 05 Feb 2021 14:39:58 +0000
> From:  Andrea Corallo via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> 
> > Native branch checkout is in: "c:/emacs/git/emacs/native/"
> >
> > "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/src/epaths.h" contains:
> >
> > #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
> > #define PATH_REL_LOADSEARCH "28.0.50/lisp"
> >
> >
> > HTH,
> >
> >     AndyM
> 
> Hi Andy could you give it a go to the following blind patch?

You assume that Windows programs don't understand "/" as a directory
separator?  They do.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 5 Feb 2021 14:42:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 05 09:42:56 2021
Received: from localhost ([127.0.0.1]:43266 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l82K0-0001Q3-Gs
	for submit <at> debbugs.gnu.org; Fri, 05 Feb 2021 09:42:56 -0500
Received: from mab.sdf.org ([205.166.94.33]:53916 helo=ma.sdf.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1l82Jx-0001Pv-Vj
 for 46256 <at> debbugs.gnu.org; Fri, 05 Feb 2021 09:42:55 -0500
Received: from akrl by ma.sdf.org with local (Exim 4.92)
 (envelope-from <akrl@HIDDEN>)
 id 1l82Jx-0005wo-GF; Fri, 05 Feb 2021 14:42:53 +0000
From: Andrea Corallo <akrl@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
 <865z38a9vo.fsf@HIDDEN>
Date: Fri, 05 Feb 2021 14:42:53 +0000
In-Reply-To: <865z38a9vo.fsf@HIDDEN> (Andy Moreton's message of "Thu, 04
 Feb 2021 01:40:11 +0000")
Message-ID: <xjfsg6apocy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andy Moreton <andrewjmoreton@HIDDEN> writes:

> On Thu 04 Feb 2021, Andy Moreton wrote:
>
>> On Wed 03 Feb 2021, akrl--- via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>>
>>> Hi Andy,
>>>
>>> could you share the values of PATH_DUMPLOADSEARCH and
>>> PATH_REL_LOADSEARCH from your epaths.h ?
>>>
>>> Thanks
>>>
>>>   Andrea
>>
>> Native branch checkout is in: "c:/emacs/git/emacs/native/"
>>
>> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/src/epaths.h" contains:
>>
>> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
>> #define PATH_REL_LOADSEARCH "28.0.50/lisp"
>
> I've bootstrapped again after the recent hash shortening to ensure my build
> is up to date, from commit 1f626e9662d8120acd5a937f847123cc2b8c6e31. The
> paths above are unchanged.
>
> Running this from the build dir, I see messages like:
>
> error in process sentinel: Native elisp load failed: "file does not exists",
>  "c:/home/ajm/.emacs.d/eln-cache/28.0.50-e2ae3598/hl-line-e67628ec-664ef650.eln"
>
> This suggests that the AOT .eln files are not being found. It should find:

AFAIK you should not get any error but the eln should be recompiled
automatically.  I guess having updated the hash algorithm the startup is
failing and you need to clean-up completely the build directory
(especially native-lisp/), please retry after a git clean -xfd.

Thanks

  Andrea

> c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/native-lisp/28.0.50-e2ae3598/hl-line-8fa29c14-664ef650.eln
>
> The middle hash (e67628ec vs. 8fa29c14) is not the same - any idea why ?
>
>    AndyM
>
>
>
>
>

-- 
akrl@HIDDEN




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 5 Feb 2021 14:40:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 05 09:40:02 2021
Received: from localhost ([127.0.0.1]:43262 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l82HB-0001Lf-Na
	for submit <at> debbugs.gnu.org; Fri, 05 Feb 2021 09:40:02 -0500
Received: from mab.sdf.org ([205.166.94.33]:51448 helo=ma.sdf.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1l82HA-0001LQ-1h
 for 46256 <at> debbugs.gnu.org; Fri, 05 Feb 2021 09:40:00 -0500
Received: from akrl by ma.sdf.org with local (Exim 4.92)
 (envelope-from <akrl@HIDDEN>)
 id 1l82H8-0005Dk-KO; Fri, 05 Feb 2021 14:39:58 +0000
From: Andrea Corallo <akrl@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
Date: Fri, 05 Feb 2021 14:39:58 +0000
In-Reply-To: <865z3866my.fsf@HIDDEN> (Andy Moreton's message of "Thu, 04
 Feb 2021 00:03:49 +0000")
Message-ID: <xjfwnvmpoht.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Andy Moreton <andrewjmoreton@HIDDEN> writes:

> On Wed 03 Feb 2021, akrl--- via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>
>> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>>
>>> Hi,
>>>
>>> I have built emacs native-comp branch for 64bit Mingw64 with
>>> NATIVE_FULL_AOT=1 (out of tree, so build dir != source dir).
>>>
>>> I notice that if I run the built emacs from the build dir then the
>>> prebuilt .eln files are ignored, and async compilation of the .eln file
>>> happens again to add them to the user eln-cache dir.
>>>
>>> The prebuilt .eln files are not found in the user eln-cache (expected)
>>> or the installed emacs directory (also expected), but it looks like it
>>> does not also check the build dir (relative to the running emacs rather
>>> than relative to the install prefix).
>>>
>>> Running from the build dir without installing is common for developers
>>> building from source, so it would be useful to keep this working with
>>> native AOT builds.
>>>
>>>     AndyM
>>
>> Hi Andy,
>>
>> could you share the values of PATH_DUMPLOADSEARCH and
>> PATH_REL_LOADSEARCH from your epaths.h ?
>>
>> Thanks
>>
>>   Andrea
>
> Native branch checkout is in: "c:/emacs/git/emacs/native/"
>
> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/src/epaths.h" contains:
>
> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
> #define PATH_REL_LOADSEARCH "28.0.50/lisp"
>
>
> HTH,
>
>     AndyM

Hi Andy could you give it a go to the following blind patch?

Thanks

  Andrea


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=46256.patch

diff --git a/src/comp.c b/src/comp.c
index 289d89d37d..980462b520 100644
--- a/src/comp.c
+++ b/src/comp.c
@@ -433,6 +433,12 @@ #define TEXT_DATA_RELOC_EPHEMERAL_SYM "text_data_reloc_eph"
 #define TEXT_OPTIM_QLY_SYM "text_optim_qly"
 #define TEXT_FDOC_SYM "text_data_fdoc"
 
+#ifdef WINDOWSNT
+#define DIR_SLASH "\\"
+#else
+#define DIR_SLASH "/"
+#endif
+
 #define STR_VALUE(s) #s
 #define STR(s) STR_VALUE (s)
 
@@ -4032,9 +4038,11 @@ DEFUN ("comp-el-to-eln-filename", Fcomp_el_to_eln_filename,
     {
       Lisp_Object sys_re =
 	concat2 (build_string ("\\`[[:ascii:]]+"),
-		 Fregexp_quote (build_string ("/" PATH_REL_LOADSEARCH "/")));
+		 Fregexp_quote (build_string (DIR_SLASH PATH_REL_LOADSEARCH
+					      DIR_SLASH)));
       loadsearch_re_list =
-	list2 (sys_re, Fregexp_quote (build_string (PATH_DUMPLOADSEARCH "/")));
+	list2 (sys_re, Fregexp_quote (build_string (PATH_DUMPLOADSEARCH
+						    DIR_SLASH)));
     }
 
   Lisp_Object lds_re_tail = loadsearch_re_list;

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 4 Feb 2021 01:40:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 03 20:40:29 2021
Received: from localhost ([127.0.0.1]:39291 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l7TdF-0004yz-Bh
	for submit <at> debbugs.gnu.org; Wed, 03 Feb 2021 20:40:29 -0500
Received: from lists.gnu.org ([209.51.188.17]:46088)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l7TdD-0004ys-Pu
 for submit <at> debbugs.gnu.org; Wed, 03 Feb 2021 20:40:28 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:43202)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l7TdB-0001Ov-Hk
 for bug-gnu-emacs@HIDDEN; Wed, 03 Feb 2021 20:40:27 -0500
Received: from ciao.gmane.io ([116.202.254.214]:39850)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l7TdA-0001h9-Az
 for bug-gnu-emacs@HIDDEN; Wed, 03 Feb 2021 20:40:25 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l7Td3-0006db-6e
 for bug-gnu-emacs@HIDDEN; Thu, 04 Feb 2021 02:40:17 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
Date: Thu, 04 Feb 2021 01:40:11 +0000
Message-ID: <865z38a9vo.fsf@HIDDEN>
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN> <865z3866my.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:XM2Wt5jtQHg7E938mxJj7CHOM+Q=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.248, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Thu 04 Feb 2021, Andy Moreton wrote:

> On Wed 03 Feb 2021, akrl--- via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>
>> Hi Andy,
>>
>> could you share the values of PATH_DUMPLOADSEARCH and
>> PATH_REL_LOADSEARCH from your epaths.h ?
>>
>> Thanks
>>
>>   Andrea
>
> Native branch checkout is in: "c:/emacs/git/emacs/native/"
>
> "c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/src/epaths.h" contains:
>
> #define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
> #define PATH_REL_LOADSEARCH "28.0.50/lisp"

I've bootstrapped again after the recent hash shortening to ensure my build
is up to date, from commit 1f626e9662d8120acd5a937f847123cc2b8c6e31. The
paths above are unchanged.

Running this from the build dir, I see messages like:

error in process sentinel: Native elisp load failed: "file does not exists",
 "c:/home/ajm/.emacs.d/eln-cache/28.0.50-e2ae3598/hl-line-e67628ec-664ef650.eln"

This suggests that the AOT .eln files are not being found. It should find:

c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/native-lisp/28.0.50-e2ae3598/hl-line-8fa29c14-664ef650.eln

The middle hash (e67628ec vs. 8fa29c14) is not the same - any idea why ?

   AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 4 Feb 2021 00:04:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 03 19:04:06 2021
Received: from localhost ([127.0.0.1]:39209 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l7S7y-0002ar-HS
	for submit <at> debbugs.gnu.org; Wed, 03 Feb 2021 19:04:06 -0500
Received: from lists.gnu.org ([209.51.188.17]:48596)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l7S7x-0002aj-0G
 for submit <at> debbugs.gnu.org; Wed, 03 Feb 2021 19:04:05 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:50142)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l7S7s-0004MW-8c
 for bug-gnu-emacs@HIDDEN; Wed, 03 Feb 2021 19:04:04 -0500
Received: from ciao.gmane.io ([116.202.254.214]:58838)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l7S7q-0004pA-3F
 for bug-gnu-emacs@HIDDEN; Wed, 03 Feb 2021 19:03:59 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1l7S7l-0004Kd-QT
 for bug-gnu-emacs@HIDDEN; Thu, 04 Feb 2021 01:03:53 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
Date: Thu, 04 Feb 2021 00:03:49 +0000
Message-ID: <865z3866my.fsf@HIDDEN>
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
 <xjfeehwri2b.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:Gw+ibyE3pEjgXvOnyp+Dinfs+OI=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.248, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Wed 03 Feb 2021, akrl--- via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:

> Andy Moreton <andrewjmoreton@HIDDEN> writes:
>
>> Hi,
>>
>> I have built emacs native-comp branch for 64bit Mingw64 with
>> NATIVE_FULL_AOT=1 (out of tree, so build dir != source dir).
>>
>> I notice that if I run the built emacs from the build dir then the
>> prebuilt .eln files are ignored, and async compilation of the .eln file
>> happens again to add them to the user eln-cache dir.
>>
>> The prebuilt .eln files are not found in the user eln-cache (expected)
>> or the installed emacs directory (also expected), but it looks like it
>> does not also check the build dir (relative to the running emacs rather
>> than relative to the install prefix).
>>
>> Running from the build dir without installing is common for developers
>> building from source, so it would be useful to keep this working with
>> native AOT builds.
>>
>>     AndyM
>
> Hi Andy,
>
> could you share the values of PATH_DUMPLOADSEARCH and
> PATH_REL_LOADSEARCH from your epaths.h ?
>
> Thanks
>
>   Andrea

Native branch checkout is in: "c:/emacs/git/emacs/native/"

"c:/emacs/git/emacs/native/build/mingw64-x86_64-O2/src/epaths.h" contains:

#define PATH_DUMPLOADSEARCH "C:/emacs/git/emacs/native/lisp"
#define PATH_REL_LOADSEARCH "28.0.50/lisp"


HTH,

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at 46256 <at> debbugs.gnu.org:


Received: (at 46256) by debbugs.gnu.org; 3 Feb 2021 20:51:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 03 15:51:30 2021
Received: from localhost ([127.0.0.1]:38984 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l7P7Z-00044f-Q9
	for submit <at> debbugs.gnu.org; Wed, 03 Feb 2021 15:51:30 -0500
Received: from mab.sdf.org ([205.166.94.33]:35724 helo=ma.sdf.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1l7P7X-00044T-M5
 for 46256 <at> debbugs.gnu.org; Wed, 03 Feb 2021 15:51:28 -0500
Received: from akrl by ma.sdf.org with local (Exim 4.92)
 (envelope-from <akrl@HIDDEN>)
 id 1l7P7U-0004jT-JI; Wed, 03 Feb 2021 20:51:24 +0000
From: Andrea Corallo <akrl@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run
 from build tree
References: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
Date: Wed, 03 Feb 2021 20:51:24 +0000
In-Reply-To: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN> (Andy Moreton's
 message of "Tue, 2 Feb 2021 11:11:08 +0000")
Message-ID: <xjfeehwri2b.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46256
Cc: 46256 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andy Moreton <andrewjmoreton@HIDDEN> writes:

> Hi,
>
> I have built emacs native-comp branch for 64bit Mingw64 with
> NATIVE_FULL_AOT=1 (out of tree, so build dir != source dir).
>
> I notice that if I run the built emacs from the build dir then the
> prebuilt .eln files are ignored, and async compilation of the .eln file
> happens again to add them to the user eln-cache dir.
>
> The prebuilt .eln files are not found in the user eln-cache (expected)
> or the installed emacs directory (also expected), but it looks like it
> does not also check the build dir (relative to the running emacs rather
> than relative to the install prefix).
>
> Running from the build dir without installing is common for developers
> building from source, so it would be useful to keep this working with
> native AOT builds.
>
>     AndyM

Hi Andy,

could you share the values of PATH_DUMPLOADSEARCH and
PATH_REL_LOADSEARCH from your epaths.h ?

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 2 Feb 2021 11:11:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 02 06:11:21 2021
Received: from localhost ([127.0.0.1]:34221 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l6tab-0000zZ-4t
	for submit <at> debbugs.gnu.org; Tue, 02 Feb 2021 06:11:21 -0500
Received: from lists.gnu.org ([209.51.188.17]:39836)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrewjmoreton@HIDDEN>) id 1l6taY-0000zI-6k
 for submit <at> debbugs.gnu.org; Tue, 02 Feb 2021 06:11:20 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:57480)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <andrewjmoreton@HIDDEN>)
 id 1l6taX-0001mS-8K
 for bug-gnu-emacs@HIDDEN; Tue, 02 Feb 2021 06:11:17 -0500
Received: from mail-wm1-x334.google.com ([2a00:1450:4864:20::334]:50189)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <andrewjmoreton@HIDDEN>)
 id 1l6taU-0006Tt-MO
 for bug-gnu-emacs@HIDDEN; Tue, 02 Feb 2021 06:11:17 -0500
Received: by mail-wm1-x334.google.com with SMTP id 190so2036665wmz.0
 for <bug-gnu-emacs@HIDDEN>; Tue, 02 Feb 2021 03:11:13 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=to:subject:from:message-id:date:user-agent:mime-version
 :content-language:content-transfer-encoding;
 bh=RUBSQxkuDW7tjunoR8zRlVKZqEAo4zF4ZvklaWGHe8o=;
 b=L/D8mxmS8tdPZ82QVj4Kso61sNRuev2F+ffIVHnvyXVtNgjY85Ox7yn+LYeAWXn5SI
 1njapF6JKUCuWOOa86scQ+sGFfEo2/45L0/wp0iGy3n62MTINR0gI8ElKWHAyC6qg2U5
 EUi3JczRvZ6YGrWhoE/zsabJdr9Plv5H/37FgEl93hPoqM9prCprqQ3RbuJzaTg+HGUt
 dC3x9gVqrN9svzrKa8n/2YtswXsb5yGvtx0MSoRPts6x+dxGTUuBmqQQFfgYUemndvV4
 ucT9FZPVPUMiHQ4OknaNWssrRk+HYAwe5mMLSUpkaMRL7yDhxdtVCkFPXvhzPHzW9J1W
 fAfQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:to:subject:from:message-id:date:user-agent
 :mime-version:content-language:content-transfer-encoding;
 bh=RUBSQxkuDW7tjunoR8zRlVKZqEAo4zF4ZvklaWGHe8o=;
 b=CdkD9lH1YgVNTjsB9gmzKhvAPeaivGMk54kXUOpiIEhZOVkdXiafrGjZ6nJ/cDcGeB
 J75xKoTR09rYdqm/hlQuKjBKa48b0P1tkBA+Pu6pWXuE8y31rVnNdp3SFU5BA54Q0PUk
 DoNkRqBqQeWmyf2XDxMJjXOjKqlsZkTTHYSWvXsyT9tg6U7R++WIrFhZ+k7LMIXgw3bo
 WGZykYUZucex8RjqO1jLJYnUR+4lJXv4mxSGPYsLlIFYFWO6FeKkKgk/IoeApI/MLe+b
 QF16lyeMxlI463TcfdAN8kuAuEuMp2W2BMtfYe3VSbwYnE26rP9UjAgdP3SonH654VLy
 gYiQ==
X-Gm-Message-State: AOAM530vnUmoG4QdKQDK0hj52P7yHLyuFabo+y9HiNlkMLXQJ3AkqkjM
 cxtoXPEcKEqFPC4ZrpTvFPsf+Q0rzgY=
X-Google-Smtp-Source: ABdhPJzVBr2hWmcFxiOYzaRSCyau424G3qhq7XhSLVlOMDIBZ1/HYHR9pn/KpLSHhnpUk2jrDr5W8w==
X-Received: by 2002:a05:600c:2253:: with SMTP id
 a19mr3016114wmm.75.1612264272311; 
 Tue, 02 Feb 2021 03:11:12 -0800 (PST)
Received: from [192.168.0.5] (82-69-64-228.dsl.in-addr.zen.co.uk.
 [82.69.64.228])
 by smtp.gmail.com with ESMTPSA id q18sm30929648wrr.55.2021.02.02.03.11.10
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Tue, 02 Feb 2021 03:11:11 -0800 (PST)
To: bug-gnu-emacs@HIDDEN
Subject: [feature/native-comp] AOT eln files ignored if run from build tree
From: Andy Moreton <andrewjmoreton@HIDDEN>
Message-ID: <e62633ce-2fb1-e943-55a5-03142b708697@HIDDEN>
Date: Tue, 2 Feb 2021 11:11:08 +0000
User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101
 Thunderbird/78.7.0
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-GB
Content-Transfer-Encoding: 7bit
Received-SPF: pass client-ip=2a00:1450:4864:20::334;
 envelope-from=andrewjmoreton@HIDDEN; helo=mail-wm1-x334.google.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Hi,

I have built emacs native-comp branch for 64bit Mingw64 with
NATIVE_FULL_AOT=1 (out of tree, so build dir != source dir).

I notice that if I run the built emacs from the build dir then the
prebuilt .eln files are ignored, and async compilation of the .eln file
happens again to add them to the user eln-cache dir.

The prebuilt .eln files are not found in the user eln-cache (expected)
or the installed emacs directory (also expected), but it looks like it
does not also check the build dir (relative to the running emacs rather
than relative to the install prefix).

Running from the build dir without installing is common for developers
building from source, so it would be useful to keep this working with
native AOT builds.

     AndyM





Acknowledgement sent to Andy Moreton <andrewjmoreton@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#46256; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 1 Mar 2021 10:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.